setup: merge configuration of repository formats
[git/gitster.git] / t / test-lib-functions.sh
blobfde9bf54fc35fc3c8802cfa3af495ea71fcfd24f
1 # Library of functions shared by all tests scripts, included by
2 # test-lib.sh.
4 # Copyright (c) 2005 Junio C Hamano
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see https://www.gnu.org/licenses/ .
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
26 # In particular, quoting isn't enough, as the path may contain the same quote
27 # that we're using.
28 test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
35 # Like test_set_editor but sets GIT_SEQUENCE_EDITOR instead of EDITOR
36 test_set_sequence_editor () {
37 FAKE_SEQUENCE_EDITOR="$1"
38 export FAKE_SEQUENCE_EDITOR
39 GIT_SEQUENCE_EDITOR='"$FAKE_SEQUENCE_EDITOR"'
40 export GIT_SEQUENCE_EDITOR
43 test_decode_color () {
44 awk '
45 function name(n) {
46 if (n == 0) return "RESET";
47 if (n == 1) return "BOLD";
48 if (n == 2) return "FAINT";
49 if (n == 3) return "ITALIC";
50 if (n == 7) return "REVERSE";
51 if (n == 30) return "BLACK";
52 if (n == 31) return "RED";
53 if (n == 32) return "GREEN";
54 if (n == 33) return "YELLOW";
55 if (n == 34) return "BLUE";
56 if (n == 35) return "MAGENTA";
57 if (n == 36) return "CYAN";
58 if (n == 37) return "WHITE";
59 if (n == 40) return "BLACK";
60 if (n == 41) return "BRED";
61 if (n == 42) return "BGREEN";
62 if (n == 43) return "BYELLOW";
63 if (n == 44) return "BBLUE";
64 if (n == 45) return "BMAGENTA";
65 if (n == 46) return "BCYAN";
66 if (n == 47) return "BWHITE";
69 while (match($0, /\033\[[0-9;]*m/) != 0) {
70 printf "%s<", substr($0, 1, RSTART-1);
71 codes = substr($0, RSTART+2, RLENGTH-3);
72 if (length(codes) == 0)
73 printf "%s", name(0)
74 else {
75 n = split(codes, ary, ";");
76 sep = "";
77 for (i = 1; i <= n; i++) {
78 printf "%s%s", sep, name(ary[i]);
79 sep = ";"
82 printf ">";
83 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
85 print
90 lf_to_nul () {
91 perl -pe 'y/\012/\000/'
94 nul_to_q () {
95 perl -pe 'y/\000/Q/'
98 q_to_nul () {
99 perl -pe 'y/Q/\000/'
102 q_to_cr () {
103 tr Q '\015'
106 q_to_tab () {
107 tr Q '\011'
110 qz_to_tab_space () {
111 tr QZ '\011\040'
114 append_cr () {
115 sed -e 's/$/Q/' | tr Q '\015'
118 remove_cr () {
119 tr '\015' Q | sed -e 's/Q$//'
122 # In some bourne shell implementations, the "unset" builtin returns
123 # nonzero status when a variable to be unset was not set in the first
124 # place.
126 # Use sane_unset when that should not be considered an error.
128 sane_unset () {
129 unset "$@"
130 return 0
133 test_tick () {
134 if test -z "${test_tick+set}"
135 then
136 test_tick=1112911993
137 else
138 test_tick=$(($test_tick + 60))
140 GIT_COMMITTER_DATE="$test_tick -0700"
141 GIT_AUTHOR_DATE="$test_tick -0700"
142 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
145 # Stop execution and start a shell. This is useful for debugging tests.
147 # Be sure to remove all invocations of this command before submitting.
148 # WARNING: the shell invoked by this helper does not have the same environment
149 # as the one running the tests (shell variables and functions are not
150 # available, and the options below further modify the environment). As such,
151 # commands copied from a test script might behave differently than when
152 # running the test.
154 # Usage: test_pause [options]
155 # -t
156 # Use your original TERM instead of test-lib.sh's "dumb".
157 # This usually restores color output in the invoked shell.
158 # -s
159 # Invoke $SHELL instead of $TEST_SHELL_PATH.
160 # -h
161 # Use your original HOME instead of test-lib.sh's "$TRASH_DIRECTORY".
162 # This allows you to use your regular shell environment and Git aliases.
163 # CAUTION: running commands copied from a test script into the paused shell
164 # might result in files in your HOME being overwritten.
165 # -a
166 # Shortcut for -t -s -h
168 test_pause () {
169 PAUSE_TERM=$TERM &&
170 PAUSE_SHELL=$TEST_SHELL_PATH &&
171 PAUSE_HOME=$HOME &&
172 while test $# != 0
174 case "$1" in
176 PAUSE_TERM="$USER_TERM"
179 PAUSE_SHELL="$SHELL"
182 PAUSE_HOME="$USER_HOME"
185 PAUSE_TERM="$USER_TERM"
186 PAUSE_SHELL="$SHELL"
187 PAUSE_HOME="$USER_HOME"
190 break
192 esac
193 shift
194 done &&
195 TERM="$PAUSE_TERM" HOME="$PAUSE_HOME" "$PAUSE_SHELL" <&6 >&5 2>&7
198 # Wrap git with a debugger. Adding this to a command can make it easier
199 # to understand what is going on in a failing test.
201 # Usage: debug [options] <git command>
202 # -d <debugger>
203 # --debugger=<debugger>
204 # Use <debugger> instead of GDB
205 # -t
206 # Use your original TERM instead of test-lib.sh's "dumb".
207 # This usually restores color output in the debugger.
208 # WARNING: the command being debugged might behave differently than when
209 # running the test.
211 # Examples:
212 # debug git checkout master
213 # debug --debugger=nemiver git $ARGS
214 # debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
215 debug () {
216 GIT_DEBUGGER=1 &&
217 DEBUG_TERM=$TERM &&
218 while test $# != 0
220 case "$1" in
222 DEBUG_TERM="$USER_TERM"
225 GIT_DEBUGGER="$2" &&
226 shift
228 --debugger=*)
229 GIT_DEBUGGER="${1#*=}"
232 break
234 esac
235 shift
236 done &&
238 dotfiles=".gdbinit .lldbinit"
240 for dotfile in $dotfiles
242 dotfile="$USER_HOME/$dotfile" &&
243 test -f "$dotfile" && cp "$dotfile" "$HOME" || :
244 done &&
246 TERM="$DEBUG_TERM" GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7 &&
248 for dotfile in $dotfiles
250 rm -f "$HOME/$dotfile"
251 done
254 # Usage: test_ref_exists [options] <ref>
256 # -C <dir>:
257 # Run all git commands in directory <dir>
259 # This helper function checks whether a reference exists. Symrefs or object IDs
260 # will not be resolved. Can be used to check references with bad names.
261 test_ref_exists () {
262 local indir=
264 while test $# != 0
266 case "$1" in
268 indir="$2"
269 shift
272 break
274 esac
275 shift
276 done &&
278 indir=${indir:+"$indir"/} &&
280 if test "$#" != 1
281 then
282 BUG "expected exactly one reference"
283 fi &&
285 git ${indir:+ -C "$indir"} show-ref --exists "$1"
288 # Behaves the same as test_ref_exists, except that it checks for the absence of
289 # a reference. This is preferable to `! test_ref_exists` as this function is
290 # able to distinguish actually-missing references from other, generic errors.
291 test_ref_missing () {
292 test_ref_exists "$@"
293 case "$?" in
295 # This is the good case.
296 return 0
299 echo >&4 "test_ref_missing: reference exists"
300 return 1
303 echo >&4 "test_ref_missing: generic error"
304 return 1
306 esac
309 # Usage: test_commit [options] <message> [<file> [<contents> [<tag>]]]
310 # -C <dir>:
311 # Run all git commands in directory <dir>
312 # --notick
313 # Do not call test_tick before making a commit
314 # --append
315 # Use ">>" instead of ">" when writing "<contents>" to "<file>"
316 # --printf
317 # Use "printf" instead of "echo" when writing "<contents>" to
318 # "<file>", use this to write escape sequences such as "\0", a
319 # trailing "\n" won't be added automatically. This option
320 # supports nothing but the FORMAT of printf(1), i.e. no custom
321 # ARGUMENT(s).
322 # --signoff
323 # Invoke "git commit" with --signoff
324 # --author <author>
325 # Invoke "git commit" with --author <author>
326 # --no-tag
327 # Do not tag the resulting commit
328 # --annotate
329 # Create an annotated tag with "--annotate -m <message>". Calls
330 # test_tick between making the commit and tag, unless --notick
331 # is given.
333 # This will commit a file with the given contents and the given commit
334 # message, and tag the resulting commit with the given tag name.
336 # <file>, <contents>, and <tag> all default to <message>.
338 test_commit () {
339 local notick= &&
340 local echo=echo &&
341 local append= &&
342 local author= &&
343 local signoff= &&
344 local indir= &&
345 local tag=light &&
346 while test $# != 0
348 case "$1" in
349 --notick)
350 notick=yes
352 --printf)
353 echo=printf
355 --append)
356 append=yes
358 --author)
359 author="$2"
360 shift
362 --signoff)
363 signoff="$1"
365 --date)
366 notick=yes
367 GIT_COMMITTER_DATE="$2"
368 GIT_AUTHOR_DATE="$2"
369 shift
372 indir="$2"
373 shift
375 --no-tag)
376 tag=none
378 --annotate)
379 tag=annotate
382 break
384 esac
385 shift
386 done &&
387 indir=${indir:+"$indir"/} &&
388 local file="${2:-"$1.t"}" &&
389 if test -n "$append"
390 then
391 $echo "${3-$1}" >>"$indir$file"
392 else
393 $echo "${3-$1}" >"$indir$file"
394 fi &&
395 git ${indir:+ -C "$indir"} add -- "$file" &&
396 if test -z "$notick"
397 then
398 test_tick
399 fi &&
400 git ${indir:+ -C "$indir"} commit \
401 ${author:+ --author "$author"} \
402 $signoff -m "$1" &&
403 case "$tag" in
404 none)
406 light)
407 git ${indir:+ -C "$indir"} tag "${4:-$1}"
409 annotate)
410 if test -z "$notick"
411 then
412 test_tick
413 fi &&
414 git ${indir:+ -C "$indir"} tag -a -m "$1" "${4:-$1}"
416 esac
419 # Call test_merge with the arguments "<message> <commit>", where <commit>
420 # can be a tag pointing to the commit-to-merge.
422 test_merge () {
423 label="$1" &&
424 shift &&
425 test_tick &&
426 git merge -m "$label" "$@" &&
427 git tag "$label"
430 # Efficiently create <nr> commits, each with a unique number (from 1 to <nr>
431 # by default) in the commit message.
433 # Usage: test_commit_bulk [options] <nr>
434 # -C <dir>:
435 # Run all git commands in directory <dir>
436 # --ref=<n>:
437 # ref on which to create commits (default: HEAD)
438 # --start=<n>:
439 # number commit messages from <n> (default: 1)
440 # --message=<msg>:
441 # use <msg> as the commit mesasge (default: "commit %s")
442 # --filename=<fn>:
443 # modify <fn> in each commit (default: %s.t)
444 # --contents=<string>:
445 # place <string> in each file (default: "content %s")
446 # --id=<string>:
447 # shorthand to use <string> and %s in message, filename, and contents
449 # The message, filename, and contents strings are evaluated by printf, with the
450 # first "%s" replaced by the current commit number. So you can do:
452 # test_commit_bulk --filename=file --contents="modification %s"
454 # to have every commit touch the same file, but with unique content.
456 test_commit_bulk () {
457 tmpfile=.bulk-commit.input
458 indir=.
459 ref=HEAD
461 notick=
462 message='commit %s'
463 filename='%s.t'
464 contents='content %s'
465 while test $# -gt 0
467 case "$1" in
469 indir=$2
470 shift
472 --ref=*)
473 ref=${1#--*=}
475 --start=*)
476 n=${1#--*=}
478 --message=*)
479 message=${1#--*=}
481 --filename=*)
482 filename=${1#--*=}
484 --contents=*)
485 contents=${1#--*=}
487 --id=*)
488 message="${1#--*=} %s"
489 filename="${1#--*=}-%s.t"
490 contents="${1#--*=} %s"
492 --notick)
493 notick=yes
496 BUG "invalid test_commit_bulk option: $1"
499 break
501 esac
502 shift
503 done
504 total=$1
506 add_from=
507 if git -C "$indir" rev-parse --quiet --verify "$ref"
508 then
509 add_from=t
512 while test "$total" -gt 0
514 if test -z "$notick"
515 then
516 test_tick
517 fi &&
518 echo "commit $ref"
519 printf 'author %s <%s> %s\n' \
520 "$GIT_AUTHOR_NAME" \
521 "$GIT_AUTHOR_EMAIL" \
522 "$GIT_AUTHOR_DATE"
523 printf 'committer %s <%s> %s\n' \
524 "$GIT_COMMITTER_NAME" \
525 "$GIT_COMMITTER_EMAIL" \
526 "$GIT_COMMITTER_DATE"
527 echo "data <<EOF"
528 printf "$message\n" $n
529 echo "EOF"
530 if test -n "$add_from"
531 then
532 echo "from $ref^0"
533 add_from=
535 printf "M 644 inline $filename\n" $n
536 echo "data <<EOF"
537 printf "$contents\n" $n
538 echo "EOF"
539 echo
540 n=$((n + 1))
541 total=$((total - 1))
542 done >"$tmpfile"
544 git -C "$indir" \
545 -c fastimport.unpacklimit=0 \
546 fast-import <"$tmpfile" || return 1
548 # This will be left in place on failure, which may aid debugging.
549 rm -f "$tmpfile"
551 # If we updated HEAD, then be nice and update the index and working
552 # tree, too.
553 if test "$ref" = "HEAD"
554 then
555 git -C "$indir" checkout -f HEAD || return 1
560 # This function helps systems where core.filemode=false is set.
561 # Use it instead of plain 'chmod +x' to set or unset the executable bit
562 # of a file in the working directory and add it to the index.
564 test_chmod () {
565 chmod "$@" &&
566 git update-index --add "--chmod=$@"
569 # Get the modebits from a file or directory, ignoring the setgid bit (g+s).
570 # This bit is inherited by subdirectories at their creation. So we remove it
571 # from the returning string to prevent callers from having to worry about the
572 # state of the bit in the test directory.
574 test_modebits () {
575 ls -ld "$1" | sed -e 's|^\(..........\).*|\1|' \
576 -e 's|^\(......\)S|\1-|' -e 's|^\(......\)s|\1x|'
579 # Unset a configuration variable, but don't fail if it doesn't exist.
580 test_unconfig () {
581 config_dir=
582 if test "$1" = -C
583 then
584 shift
585 config_dir=$1
586 shift
588 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
589 config_status=$?
590 case "$config_status" in
591 5) # ok, nothing to unset
592 config_status=0
594 esac
595 return $config_status
598 # Set git config, automatically unsetting it after the test is over.
599 test_config () {
600 config_dir=
601 if test "$1" = -C
602 then
603 shift
604 config_dir=$1
605 shift
608 # If --worktree is provided, use it to configure/unconfigure
609 is_worktree=
610 if test "$1" = --worktree
611 then
612 is_worktree=1
613 shift
616 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} ${is_worktree:+--worktree} '$1'" &&
617 git ${config_dir:+-C "$config_dir"} config ${is_worktree:+--worktree} "$@"
620 test_config_global () {
621 test_when_finished "test_unconfig --global '$1'" &&
622 git config --global "$@"
625 write_script () {
627 echo "#!${2-"$SHELL_PATH"}" &&
629 } >"$1" &&
630 chmod +x "$1"
633 # Usage: test_hook [options] <hook-name> <<-\EOF
635 # -C <dir>:
636 # Run all git commands in directory <dir>
637 # --setup
638 # Setup a hook for subsequent tests, i.e. don't remove it in a
639 # "test_when_finished"
640 # --clobber
641 # Overwrite an existing <hook-name>, if it exists. Implies
642 # --setup (i.e. the "test_when_finished" is assumed to have been
643 # set up already).
644 # --disable
645 # Disable (chmod -x) an existing <hook-name>, which must exist.
646 # --remove
647 # Remove (rm -f) an existing <hook-name>, which must exist.
648 test_hook () {
649 setup= &&
650 clobber= &&
651 disable= &&
652 remove= &&
653 indir= &&
654 while test $# != 0
656 case "$1" in
658 indir="$2" &&
659 shift
661 --setup)
662 setup=t
664 --clobber)
665 clobber=t
667 --disable)
668 disable=t
670 --remove)
671 remove=t
674 BUG "invalid argument: $1"
677 break
679 esac &&
680 shift
681 done &&
683 git_dir=$(git -C "$indir" rev-parse --absolute-git-dir) &&
684 hook_dir="$git_dir/hooks" &&
685 hook_file="$hook_dir/$1" &&
686 if test -n "$disable$remove"
687 then
688 test_path_is_file "$hook_file" &&
689 if test -n "$disable"
690 then
691 chmod -x "$hook_file"
692 elif test -n "$remove"
693 then
694 rm -f "$hook_file"
695 fi &&
696 return 0
697 fi &&
698 if test -z "$clobber"
699 then
700 test_path_is_missing "$hook_file"
701 fi &&
702 if test -z "$setup$clobber"
703 then
704 test_when_finished "rm \"$hook_file\""
705 fi &&
706 write_script "$hook_file"
709 # Use test_set_prereq to tell that a particular prerequisite is available.
710 # The prerequisite can later be checked for in two ways:
712 # - Explicitly using test_have_prereq.
714 # - Implicitly by specifying the prerequisite tag in the calls to
715 # test_expect_{success,failure}
717 # The single parameter is the prerequisite tag (a simple word, in all
718 # capital letters by convention).
720 test_unset_prereq () {
721 ! test_have_prereq "$1" ||
722 satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
725 test_set_prereq () {
726 if test -n "$GIT_TEST_FAIL_PREREQS_INTERNAL"
727 then
728 case "$1" in
729 # The "!" case is handled below with
730 # test_unset_prereq()
733 # List of things we can't easily pretend to not support
734 SYMLINKS)
736 # Inspecting whether GIT_TEST_FAIL_PREREQS is on
737 # should be unaffected.
738 FAIL_PREREQS)
741 return
742 esac
745 case "$1" in
747 test_unset_prereq "${1#!}"
750 satisfied_prereq="$satisfied_prereq$1 "
752 esac
754 satisfied_prereq=" "
755 lazily_testable_prereq= lazily_tested_prereq=
757 # Usage: test_lazy_prereq PREREQ 'script'
758 test_lazy_prereq () {
759 lazily_testable_prereq="$lazily_testable_prereq$1 "
760 eval test_prereq_lazily_$1=\$2
763 test_run_lazy_prereq_ () {
764 script='
765 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir-'"$1"'" &&
767 cd "$TRASH_DIRECTORY/prereq-test-dir-'"$1"'" &&'"$2"'
769 say >&3 "checking prerequisite: $1"
770 say >&3 "$script"
771 test_eval_ "$script"
772 eval_ret=$?
773 rm -rf "$TRASH_DIRECTORY/prereq-test-dir-$1"
774 if test "$eval_ret" = 0; then
775 say >&3 "prerequisite $1 ok"
776 else
777 say >&3 "prerequisite $1 not satisfied"
779 return $eval_ret
782 test_have_prereq () {
783 # prerequisites can be concatenated with ','
784 save_IFS=$IFS
785 IFS=,
786 set -- $*
787 IFS=$save_IFS
789 total_prereq=0
790 ok_prereq=0
791 missing_prereq=
793 for prerequisite
795 case "$prerequisite" in
797 negative_prereq=t
798 prerequisite=${prerequisite#!}
801 negative_prereq=
802 esac
804 case " $lazily_tested_prereq " in
805 *" $prerequisite "*)
808 case " $lazily_testable_prereq " in
809 *" $prerequisite "*)
810 eval "script=\$test_prereq_lazily_$prerequisite" &&
811 if test_run_lazy_prereq_ "$prerequisite" "$script"
812 then
813 test_set_prereq $prerequisite
815 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
816 esac
818 esac
820 total_prereq=$(($total_prereq + 1))
821 case "$satisfied_prereq" in
822 *" $prerequisite "*)
823 satisfied_this_prereq=t
826 satisfied_this_prereq=
827 esac
829 case "$satisfied_this_prereq,$negative_prereq" in
830 t,|,t)
831 ok_prereq=$(($ok_prereq + 1))
834 # Keep a list of missing prerequisites; restore
835 # the negative marker if necessary.
836 prerequisite=${negative_prereq:+!}$prerequisite
838 # Abort if this prereq was marked as required
839 if test -n "$GIT_TEST_REQUIRE_PREREQ"
840 then
841 case " $GIT_TEST_REQUIRE_PREREQ " in
842 *" $prerequisite "*)
843 BAIL_OUT "required prereq $prerequisite failed"
845 esac
848 if test -z "$missing_prereq"
849 then
850 missing_prereq=$prerequisite
851 else
852 missing_prereq="$prerequisite,$missing_prereq"
854 esac
855 done
857 test $total_prereq = $ok_prereq
860 test_declared_prereq () {
861 case ",$test_prereq," in
862 *,$1,*)
863 return 0
865 esac
866 return 1
869 test_verify_prereq () {
870 test -z "$test_prereq" ||
871 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
872 BUG "'$test_prereq' does not look like a prereq"
875 # assign the variable named by "$1" with the contents of "$2";
876 # if "$2" is "-", then read stdin into "$1" instead
877 test_body_or_stdin () {
878 if test "$2" != "-"
879 then
880 eval "$1=\$2"
881 return
884 # start with a newline, to match hanging newline from open-quote style
885 eval "$1=\$LF"
886 local test_line
887 while IFS= read -r test_line
889 eval "$1=\${$1}\${test_line}\${LF}"
890 done
893 test_expect_failure () {
894 test_start_ "$@"
895 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
896 test "$#" = 2 ||
897 BUG "not 2 or 3 parameters to test-expect-failure"
898 test_verify_prereq
899 export test_prereq
900 if ! test_skip "$@"
901 then
902 local test_body
903 test_body_or_stdin test_body "$2"
904 test -n "$test_skip_test_preamble" ||
905 say >&3 "checking known breakage of $TEST_NUMBER.$test_count '$1': $test_body"
906 if test_run_ "$test_body" expecting_failure
907 then
908 test_known_broken_ok_ "$1"
909 else
910 test_known_broken_failure_ "$1"
913 test_finish_
916 test_expect_success () {
917 test_start_ "$@"
918 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
919 test "$#" = 2 ||
920 BUG "not 2 or 3 parameters to test-expect-success"
921 test_verify_prereq
922 export test_prereq
923 if ! test_skip "$@"
924 then
925 local test_body
926 test_body_or_stdin test_body "$2"
927 test -n "$test_skip_test_preamble" ||
928 say >&3 "expecting success of $TEST_NUMBER.$test_count '$1': $test_body"
929 if test_run_ "$test_body"
930 then
931 test_ok_ "$1"
932 else
933 test_failure_ "$1" "$test_body"
936 test_finish_
939 # debugging-friendly alternatives to "test [-f|-d|-e]"
940 # The commands test the existence or non-existence of $1
941 test_path_is_file () {
942 test "$#" -ne 1 && BUG "1 param"
943 if ! test -f "$1"
944 then
945 echo "File $1 doesn't exist"
946 false
950 test_path_is_file_not_symlink () {
951 test "$#" -ne 1 && BUG "1 param"
952 test_path_is_file "$1" &&
953 if test -h "$1"
954 then
955 echo "$1 shouldn't be a symbolic link"
956 false
960 test_path_is_dir () {
961 test "$#" -ne 1 && BUG "1 param"
962 if ! test -d "$1"
963 then
964 echo "Directory $1 doesn't exist"
965 false
969 test_path_is_dir_not_symlink () {
970 test "$#" -ne 1 && BUG "1 param"
971 test_path_is_dir "$1" &&
972 if test -h "$1"
973 then
974 echo "$1 shouldn't be a symbolic link"
975 false
979 test_path_exists () {
980 test "$#" -ne 1 && BUG "1 param"
981 if ! test -e "$1"
982 then
983 echo "Path $1 doesn't exist"
984 false
988 test_path_is_symlink () {
989 test "$#" -ne 1 && BUG "1 param"
990 if ! test -h "$1"
991 then
992 echo "Symbolic link $1 doesn't exist"
993 false
997 test_path_is_executable () {
998 test "$#" -ne 1 && BUG "1 param"
999 if ! test -x "$1"
1000 then
1001 echo "$1 is not executable"
1002 false
1006 # Check if the directory exists and is empty as expected, barf otherwise.
1007 test_dir_is_empty () {
1008 test "$#" -ne 1 && BUG "1 param"
1009 test_path_is_dir "$1" &&
1010 if test -n "$(ls -a1 "$1" | grep -E -v '^\.\.?$')"
1011 then
1012 echo "Directory '$1' is not empty, it contains:"
1013 ls -la "$1"
1014 return 1
1018 # Check if the file exists and has a size greater than zero
1019 test_file_not_empty () {
1020 test "$#" = 2 && BUG "2 param"
1021 if ! test -s "$1"
1022 then
1023 echo "'$1' is not a non-empty file."
1024 false
1028 test_path_is_missing () {
1029 test "$#" -ne 1 && BUG "1 param"
1030 if test -e "$1"
1031 then
1032 echo "Path exists:"
1033 ls -ld "$1"
1034 false
1038 # test_line_count checks that a file has the number of lines it
1039 # ought to. For example:
1041 # test_expect_success 'produce exactly one line of output' '
1042 # do something >output &&
1043 # test_line_count = 1 output
1046 # is like "test $(wc -l <output) = 1" except that it passes the
1047 # output through when the number of lines is wrong.
1049 test_line_count () {
1050 if test $# != 3
1051 then
1052 BUG "not 3 parameters to test_line_count"
1053 elif ! test $(wc -l <"$3") "$1" "$2"
1054 then
1055 echo "test_line_count: line count for $3 !$1 $2"
1056 cat "$3"
1057 return 1
1061 # SYNOPSIS:
1062 # test_stdout_line_count <bin-ops> <value> <cmd> [<args>...]
1064 # test_stdout_line_count checks that the output of a command has the number
1065 # of lines it ought to. For example:
1067 # test_stdout_line_count = 3 git ls-files -u
1068 # test_stdout_line_count -gt 10 ls
1069 test_stdout_line_count () {
1070 local ops val trashdir &&
1071 if test "$#" -le 3
1072 then
1073 BUG "expect 3 or more arguments"
1074 fi &&
1075 ops="$1" &&
1076 val="$2" &&
1077 shift 2 &&
1078 if ! trashdir="$(git rev-parse --git-dir)/trash"; then
1079 BUG "expect to be run inside a worktree"
1080 fi &&
1081 mkdir -p "$trashdir" &&
1082 "$@" >"$trashdir/output" &&
1083 test_line_count "$ops" "$val" "$trashdir/output"
1087 test_file_size () {
1088 test "$#" -ne 1 && BUG "1 param"
1089 test-tool path-utils file-size "$1"
1092 # Returns success if a comma separated string of keywords ($1) contains a
1093 # given keyword ($2).
1094 # Examples:
1095 # `list_contains "foo,bar" bar` returns 0
1096 # `list_contains "foo" bar` returns 1
1098 list_contains () {
1099 case ",$1," in
1100 *,$2,*)
1101 return 0
1103 esac
1104 return 1
1107 # Returns success if the arguments indicate that a command should be
1108 # accepted by test_must_fail(). If the command is run with env, the env
1109 # and its corresponding variable settings will be stripped before we
1110 # test the command being run.
1111 test_must_fail_acceptable () {
1112 if test "$1" = "env"
1113 then
1114 shift
1115 while test $# -gt 0
1117 case "$1" in
1118 *?=*)
1119 shift
1122 break
1124 esac
1125 done
1128 if test "$1" = "nongit"
1129 then
1130 shift
1133 case "$1" in
1134 git|__git*|scalar|test-tool|test_terminal)
1135 return 0
1138 return 1
1140 esac
1143 # This is not among top-level (test_expect_success | test_expect_failure)
1144 # but is a prefix that can be used in the test script, like:
1146 # test_expect_success 'complain and die' '
1147 # do something &&
1148 # do something else &&
1149 # test_must_fail git checkout ../outerspace
1152 # Writing this as "! git checkout ../outerspace" is wrong, because
1153 # the failure could be due to a segv. We want a controlled failure.
1155 # Accepts the following options:
1157 # ok=<signal-name>[,<...>]:
1158 # Don't treat an exit caused by the given signal as error.
1159 # Multiple signals can be specified as a comma separated list.
1160 # Currently recognized signal names are: sigpipe, success.
1161 # (Don't use 'success', use 'test_might_fail' instead.)
1163 # Do not use this to run anything but "git" and other specific testable
1164 # commands (see test_must_fail_acceptable()). We are not in the
1165 # business of vetting system supplied commands -- in other words, this
1166 # is wrong:
1168 # test_must_fail grep pattern output
1170 # Instead use '!':
1172 # ! grep pattern output
1174 test_must_fail () {
1175 case "$1" in
1176 ok=*)
1177 _test_ok=${1#ok=}
1178 shift
1181 _test_ok=
1183 esac
1184 if ! test_must_fail_acceptable "$@"
1185 then
1186 echo >&7 "test_must_fail: only 'git' is allowed: $*"
1187 return 1
1189 "$@" 2>&7
1190 exit_code=$?
1191 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
1192 then
1193 echo >&4 "test_must_fail: command succeeded: $*"
1194 return 1
1195 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
1196 then
1197 return 0
1198 elif test $exit_code -gt 129 && test $exit_code -le 192
1199 then
1200 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
1201 return 1
1202 elif test $exit_code -eq 127
1203 then
1204 echo >&4 "test_must_fail: command not found: $*"
1205 return 1
1206 elif test $exit_code -eq 126
1207 then
1208 echo >&4 "test_must_fail: valgrind error: $*"
1209 return 1
1211 return 0
1212 } 7>&2 2>&4
1214 # Similar to test_must_fail, but tolerates success, too. This is
1215 # meant to be used in contexts like:
1217 # test_expect_success 'some command works without configuration' '
1218 # test_might_fail git config --unset all.configuration &&
1219 # do something
1222 # Writing "git config --unset all.configuration || :" would be wrong,
1223 # because we want to notice if it fails due to segv.
1225 # Accepts the same options as test_must_fail.
1227 test_might_fail () {
1228 test_must_fail ok=success "$@" 2>&7
1229 } 7>&2 2>&4
1231 # Similar to test_must_fail and test_might_fail, but check that a
1232 # given command exited with a given exit code. Meant to be used as:
1234 # test_expect_success 'Merge with d/f conflicts' '
1235 # test_expect_code 1 git merge "merge msg" B master
1238 test_expect_code () {
1239 want_code=$1
1240 shift
1241 "$@" 2>&7
1242 exit_code=$?
1243 if test $exit_code = $want_code
1244 then
1245 return 0
1248 echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
1249 return 1
1250 } 7>&2 2>&4
1252 # test_cmp is a helper function to compare actual and expected output.
1253 # You can use it like:
1255 # test_expect_success 'foo works' '
1256 # echo expected >expected &&
1257 # foo >actual &&
1258 # test_cmp expected actual
1261 # This could be written as either "cmp" or "diff -u", but:
1262 # - cmp's output is not nearly as easy to read as diff -u
1263 # - not all diff versions understand "-u"
1265 test_cmp () {
1266 test "$#" -ne 2 && BUG "2 param"
1267 eval "$GIT_TEST_CMP" '"$@"'
1270 # Check that the given config key has the expected value.
1272 # test_cmp_config [-C <dir>] <expected-value>
1273 # [<git-config-options>...] <config-key>
1275 # for example to check that the value of core.bar is foo
1277 # test_cmp_config foo core.bar
1279 test_cmp_config () {
1280 local GD &&
1281 if test "$1" = "-C"
1282 then
1283 shift &&
1284 GD="-C $1" &&
1285 shift
1286 fi &&
1287 printf "%s\n" "$1" >expect.config &&
1288 shift &&
1289 git $GD config "$@" >actual.config &&
1290 test_cmp expect.config actual.config
1293 # test_cmp_bin - helper to compare binary files
1295 test_cmp_bin () {
1296 test "$#" -ne 2 && BUG "2 param"
1297 cmp "$@"
1300 test_i18ngrep () {
1301 BUG "do not use test_i18ngrep---use test_grep instead"
1304 test_grep () {
1305 eval "last_arg=\${$#}"
1307 test -f "$last_arg" ||
1308 BUG "test_grep requires a file to read as the last parameter"
1310 if test $# -lt 2 ||
1311 { test "x!" = "x$1" && test $# -lt 3 ; }
1312 then
1313 BUG "too few parameters to test_grep"
1316 if test "x!" = "x$1"
1317 then
1318 shift
1319 ! grep "$@" && return 0
1321 echo >&4 "error: '! grep $@' did find a match in:"
1322 else
1323 grep "$@" && return 0
1325 echo >&4 "error: 'grep $@' didn't find a match in:"
1328 if test -s "$last_arg"
1329 then
1330 cat >&4 "$last_arg"
1331 else
1332 echo >&4 "<File '$last_arg' is empty>"
1335 return 1
1338 # Check if the file expected to be empty is indeed empty, and barfs
1339 # otherwise.
1341 test_must_be_empty () {
1342 test "$#" -ne 1 && BUG "1 param"
1343 test_path_is_file "$1" &&
1344 if test -s "$1"
1345 then
1346 echo "'$1' is not empty, it contains:"
1347 cat "$1"
1348 return 1
1352 # Tests that its two parameters refer to the same revision, or if '!' is
1353 # provided first, that its other two parameters refer to different
1354 # revisions.
1355 test_cmp_rev () {
1356 local op='=' wrong_result=different
1358 if test $# -ge 1 && test "x$1" = 'x!'
1359 then
1360 op='!='
1361 wrong_result='the same'
1362 shift
1364 if test $# != 2
1365 then
1366 BUG "test_cmp_rev requires two revisions, but got $#"
1367 else
1368 local r1 r2
1369 r1=$(git rev-parse --verify "$1") &&
1370 r2=$(git rev-parse --verify "$2") || return 1
1372 if ! test "$r1" "$op" "$r2"
1373 then
1374 cat >&4 <<-EOF
1375 error: two revisions point to $wrong_result objects:
1376 '$1': $r1
1377 '$2': $r2
1379 return 1
1384 # Tests that a commit message matches the expected text
1386 # Usage: test_commit_message <rev> [-m <msg> | <file>]
1388 # When using "-m" <msg> will have a line feed appended. If the second
1389 # argument is omitted then the expected message is read from stdin.
1391 test_commit_message () {
1392 local msg_file=expect.msg
1394 case $# in
1396 if test "$2" = "-m"
1397 then
1398 printf "%s\n" "$3" >"$msg_file"
1399 else
1400 BUG "Usage: test_commit_message <rev> [-m <message> | <file>]"
1404 msg_file="$2"
1407 cat >"$msg_file"
1410 BUG "Usage: test_commit_message <rev> [-m <message> | <file>]"
1412 esac
1413 git show --no-patch --pretty=format:%B "$1" -- >actual.msg &&
1414 test_cmp "$msg_file" actual.msg
1417 # Compare paths respecting core.ignoreCase
1418 test_cmp_fspath () {
1419 if test "x$1" = "x$2"
1420 then
1421 return 0
1424 if test true != "$(git config --get --type=bool core.ignorecase)"
1425 then
1426 return 1
1429 test "x$(echo "$1" | tr A-Z a-z)" = "x$(echo "$2" | tr A-Z a-z)"
1432 # Print a sequence of integers in increasing order, either with
1433 # two arguments (start and end):
1435 # test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
1437 # or with one argument (end), in which case it starts counting
1438 # from 1.
1440 test_seq () {
1441 case $# in
1442 1) set 1 "$@" ;;
1443 2) ;;
1444 *) BUG "not 1 or 2 parameters to test_seq" ;;
1445 esac
1446 test_seq_counter__=$1
1447 while test "$test_seq_counter__" -le "$2"
1449 echo "$test_seq_counter__"
1450 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
1451 done
1454 # This function can be used to schedule some commands to be run
1455 # unconditionally at the end of the test to restore sanity:
1457 # test_expect_success 'test core.capslock' '
1458 # git config core.capslock true &&
1459 # test_when_finished "git config --unset core.capslock" &&
1460 # hello world
1463 # That would be roughly equivalent to
1465 # test_expect_success 'test core.capslock' '
1466 # git config core.capslock true &&
1467 # hello world
1468 # git config --unset core.capslock
1471 # except that the greeting and config --unset must both succeed for
1472 # the test to pass.
1474 # Note that under --immediate mode, no clean-up is done to help diagnose
1475 # what went wrong.
1477 test_when_finished () {
1478 # We cannot detect when we are in a subshell in general, but by
1479 # doing so on Bash is better than nothing (the test will
1480 # silently pass on other shells).
1481 test "${BASH_SUBSHELL-0}" = 0 ||
1482 BUG "test_when_finished does nothing in a subshell"
1483 test_cleanup="{ $*
1484 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1487 # This function can be used to schedule some commands to be run
1488 # unconditionally at the end of the test script, e.g. to stop a daemon:
1490 # test_expect_success 'test git daemon' '
1491 # git daemon &
1492 # daemon_pid=$! &&
1493 # test_atexit 'kill $daemon_pid' &&
1494 # hello world
1497 # The commands will be executed before the trash directory is removed,
1498 # i.e. the atexit commands will still be able to access any pidfiles or
1499 # socket files.
1501 # Note that these commands will be run even when a test script run
1502 # with '--immediate' fails. Be careful with your atexit commands to
1503 # minimize any changes to the failed state.
1505 test_atexit () {
1506 # We cannot detect when we are in a subshell in general, but by
1507 # doing so on Bash is better than nothing (the test will
1508 # silently pass on other shells).
1509 test "${BASH_SUBSHELL-0}" = 0 ||
1510 BUG "test_atexit does nothing in a subshell"
1511 test_atexit_cleanup="{ $*
1512 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_atexit_cleanup"
1515 # Deprecated wrapper for "git init", use "git init" directly instead
1516 # Usage: test_create_repo <directory>
1517 test_create_repo () {
1518 git init "$@"
1521 # This function helps on symlink challenged file systems when it is not
1522 # important that the file system entry is a symbolic link.
1523 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
1524 # symbolic link entry y to the index.
1526 test_ln_s_add () {
1527 if test_have_prereq SYMLINKS
1528 then
1529 ln -s "$1" "$2" &&
1530 git update-index --add "$2"
1531 else
1532 printf '%s' "$1" >"$2" &&
1533 ln_s_obj=$(git hash-object -w "$2") &&
1534 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
1535 # pick up stat info from the file
1536 git update-index "$2"
1540 # This function writes out its parameters, one per line
1541 test_write_lines () {
1542 printf "%s\n" "$@"
1545 perl () {
1546 command "$PERL_PATH" "$@" 2>&7
1547 } 7>&2 2>&4
1549 # Given the name of an environment variable with a bool value, normalize
1550 # its value to a 0 (true) or 1 (false or empty string) return code.
1552 # test_bool_env GIT_TEST_HTTPD <default-value>
1554 # Return with code corresponding to the given default value if the variable
1555 # is unset.
1556 # Abort the test script if either the value of the variable or the default
1557 # are not valid bool values.
1559 test_bool_env () {
1560 if test $# != 2
1561 then
1562 BUG "test_bool_env requires two parameters (variable name and default value)"
1565 test-tool env-helper --type=bool --default="$2" --exit-code "$1"
1566 ret=$?
1567 case $ret in
1568 0|1) # unset or valid bool value
1570 *) # invalid bool value or something unexpected
1571 error >&7 "test_bool_env requires bool values both for \$$1 and for the default fallback"
1573 esac
1574 return $ret
1577 # Exit the test suite, either by skipping all remaining tests or by
1578 # exiting with an error. If our prerequisite variable $1 falls back
1579 # on a default assume we were opportunistically trying to set up some
1580 # tests and we skip. If it is explicitly "true", then we report a failure.
1582 # The error/skip message should be given by $2.
1584 test_skip_or_die () {
1585 if ! test_bool_env "$1" false
1586 then
1587 skip_all=$2
1588 test_done
1590 error "$2"
1593 # Like "env FOO=BAR some-program", but run inside a subshell, which means
1594 # it also works for shell functions (though those functions cannot impact
1595 # the environment outside of the test_env invocation).
1596 test_env () {
1598 while test $# -gt 0
1600 case "$1" in
1601 *=*)
1602 eval "${1%%=*}=\${1#*=}"
1603 eval "export ${1%%=*}"
1604 shift
1607 "$@" 2>&7
1608 exit
1610 esac
1611 done
1613 } 7>&2 2>&4
1615 # Returns true if the numeric exit code in "$2" represents the expected signal
1616 # in "$1". Signals should be given numerically.
1617 test_match_signal () {
1618 if test "$2" = "$((128 + $1))"
1619 then
1620 # POSIX
1621 return 0
1622 elif test "$2" = "$((256 + $1))"
1623 then
1624 # ksh
1625 return 0
1627 return 1
1630 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1631 test_copy_bytes () {
1632 perl -e '
1633 my $len = $ARGV[1];
1634 while ($len > 0) {
1635 my $s;
1636 my $nread = sysread(STDIN, $s, $len);
1637 die "cannot read: $!" unless defined($nread);
1638 last unless $nread;
1639 print $s;
1640 $len -= $nread;
1642 ' - "$1"
1645 # run "$@" inside a non-git directory
1646 nongit () {
1647 test -d non-repo ||
1648 mkdir non-repo ||
1649 return 1
1652 GIT_CEILING_DIRECTORIES=$(pwd) &&
1653 export GIT_CEILING_DIRECTORIES &&
1654 cd non-repo &&
1655 "$@" 2>&7
1657 } 7>&2 2>&4
1659 # These functions are historical wrappers around "test-tool pkt-line"
1660 # for older tests. Use "test-tool pkt-line" itself in new tests.
1661 packetize () {
1662 if test $# -gt 0
1663 then
1664 packet="$*"
1665 printf '%04x%s' "$((4 + ${#packet}))" "$packet"
1666 else
1667 test-tool pkt-line pack
1671 packetize_raw () {
1672 test-tool pkt-line pack-raw-stdin
1675 depacketize () {
1676 test-tool pkt-line unpack
1679 # Converts base-16 data into base-8. The output is given as a sequence of
1680 # escaped octals, suitable for consumption by 'printf'.
1681 hex2oct () {
1682 perl -ne 'printf "\\%03o", hex for /../g'
1685 # Set the hash algorithm in use to $1. Only useful when testing the testsuite.
1686 test_set_hash () {
1687 test_hash_algo="$1"
1690 # Detect the hash algorithm in use.
1691 test_detect_hash () {
1692 case "$GIT_TEST_DEFAULT_HASH" in
1693 "sha256")
1694 test_hash_algo=sha256
1695 test_compat_hash_algo=sha1
1698 test_hash_algo=sha1
1699 test_compat_hash_algo=sha256
1701 esac
1704 # Detect the hash algorithm in use.
1705 test_detect_ref_format () {
1706 echo "${GIT_TEST_DEFAULT_REF_FORMAT:-files}"
1709 # Load common hash metadata and common placeholder object IDs for use with
1710 # test_oid.
1711 test_oid_init () {
1712 test -n "$test_hash_algo" || test_detect_hash &&
1713 test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1714 test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1717 # Load key-value pairs from stdin suitable for use with test_oid. Blank lines
1718 # and lines starting with "#" are ignored. Keys must be shell identifier
1719 # characters.
1721 # Examples:
1722 # rawsz sha1:20
1723 # rawsz sha256:32
1724 test_oid_cache () {
1725 local tag rest k v &&
1727 { test -n "$test_hash_algo" || test_detect_hash; } &&
1728 while read tag rest
1730 case $tag in
1731 \#*)
1732 continue;;
1734 # non-empty
1737 # blank line
1738 continue;;
1739 esac &&
1741 k="${rest%:*}" &&
1742 v="${rest#*:}" &&
1744 if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1745 then
1746 BUG 'bad hash algorithm'
1747 fi &&
1748 eval "test_oid_${k}_$tag=\"\$v\""
1749 done
1752 # Look up a per-hash value based on a key ($1). The value must have been loaded
1753 # by test_oid_init or test_oid_cache.
1754 test_oid () {
1755 local algo="${test_hash_algo}" &&
1757 case "$1" in
1758 --hash=storage)
1759 algo="$test_hash_algo" &&
1760 shift;;
1761 --hash=compat)
1762 algo="$test_compat_hash_algo" &&
1763 shift;;
1764 --hash=*)
1765 algo="${1#--hash=}" &&
1766 shift;;
1769 esac &&
1771 local var="test_oid_${algo}_$1" &&
1773 # If the variable is unset, we must be missing an entry for this
1774 # key-hash pair, so exit with an error.
1775 if eval "test -z \"\${$var+set}\""
1776 then
1777 BUG "undefined key '$1'"
1778 fi &&
1779 eval "printf '%s\n' \"\${$var}\""
1782 # Insert a slash into an object ID so it can be used to reference a location
1783 # under ".git/objects". For example, "deadbeef..." becomes "de/adbeef..".
1784 test_oid_to_path () {
1785 local basename="${1#??}"
1786 echo "${1%$basename}/$basename"
1789 # Parse oids from git ls-files --staged output
1790 test_parse_ls_files_stage_oids () {
1791 awk '{print $2}' -
1794 # Parse oids from git ls-tree output
1795 test_parse_ls_tree_oids () {
1796 awk '{print $3}' -
1799 # Choose a port number based on the test script's number and store it in
1800 # the given variable name, unless that variable already contains a number.
1801 test_set_port () {
1802 local var="$1" port
1804 if test $# -ne 1 || test -z "$var"
1805 then
1806 BUG "test_set_port requires a variable name"
1809 eval port=\$$var
1810 case "$port" in
1812 # No port is set in the given env var, use the test
1813 # number as port number instead.
1814 # Remove not only the leading 't', but all leading zeros
1815 # as well, so the arithmetic below won't (mis)interpret
1816 # a test number like '0123' as an octal value.
1817 port=${this_test#${this_test%%[1-9]*}}
1818 if test "${port:-0}" -lt 1024
1819 then
1820 # root-only port, use a larger one instead.
1821 port=$(($port + 10000))
1824 *[!0-9]*|0*)
1825 error >&7 "invalid port number: $port"
1828 # The user has specified the port.
1830 esac
1832 # Make sure that parallel '--stress' test jobs get different
1833 # ports.
1834 port=$(($port + ${GIT_TEST_STRESS_JOB_NR:-0}))
1835 eval $var=$port
1838 # Tests for the hidden file attribute on Windows
1839 test_path_is_hidden () {
1840 test_have_prereq MINGW ||
1841 BUG "test_path_is_hidden can only be used on Windows"
1843 # Use the output of `attrib`, ignore the absolute path
1844 case "$("$SYSTEMROOT"/system32/attrib "$1")" in *H*?:*) return 0;; esac
1845 return 1
1848 # Poor man's URI escaping. Good enough for the test suite whose trash
1849 # directory has a space in it. See 93c3fcbe4d4 (git-svn: attempt to
1850 # mimic SVN 1.7 URL canonicalization, 2012-07-28) for prior art.
1851 test_uri_escape() {
1852 sed 's/ /%20/g'
1855 # Check that the given command was invoked as part of the
1856 # trace2-format trace on stdin.
1858 # test_subcommand [!] <command> <args>... < <trace>
1860 # For example, to look for an invocation of "git upload-pack
1861 # /path/to/repo"
1863 # GIT_TRACE2_EVENT=event.log git fetch ... &&
1864 # test_subcommand git upload-pack "$PATH" <event.log
1866 # If the first parameter passed is !, this instead checks that
1867 # the given command was not called.
1869 test_subcommand () {
1870 local negate=
1871 if test "$1" = "!"
1872 then
1873 negate=t
1874 shift
1877 local expr="$(printf '"%s",' "$@")"
1878 expr="${expr%,}"
1880 if test -n "$negate"
1881 then
1882 ! grep "\[$expr\]"
1883 else
1884 grep "\[$expr\]"
1888 # Check that the given command was invoked as part of the
1889 # trace2-format trace on stdin.
1891 # test_region [!] <category> <label> git <command> <args>...
1893 # For example, to look for trace2_region_enter("index", "do_read_index", repo)
1894 # in an invocation of "git checkout HEAD~1", run
1896 # GIT_TRACE2_EVENT="$(pwd)/trace.txt" GIT_TRACE2_EVENT_NESTING=10 \
1897 # git checkout HEAD~1 &&
1898 # test_region index do_read_index <trace.txt
1900 # If the first parameter passed is !, this instead checks that
1901 # the given region was not entered.
1903 test_region () {
1904 local expect_exit=0
1905 if test "$1" = "!"
1906 then
1907 expect_exit=1
1908 shift
1911 grep -e '"region_enter".*"category":"'"$1"'","label":"'"$2"\" "$3"
1912 exitcode=$?
1914 if test $exitcode != $expect_exit
1915 then
1916 return 1
1919 grep -e '"region_leave".*"category":"'"$1"'","label":"'"$2"\" "$3"
1920 exitcode=$?
1922 if test $exitcode != $expect_exit
1923 then
1924 return 1
1927 return 0
1930 # Check that the given data fragment was included as part of the
1931 # trace2-format trace on stdin.
1933 # test_trace2_data <category> <key> <value>
1935 # For example, to look for trace2_data_intmax("pack-objects", repo,
1936 # "reused", N) in an invocation of "git pack-objects", run:
1938 # GIT_TRACE2_EVENT="$(pwd)/trace.txt" git pack-objects ... &&
1939 # test_trace2_data pack-objects reused N <trace2.txt
1940 test_trace2_data () {
1941 grep -e '"category":"'"$1"'","key":"'"$2"'","value":"'"$3"'"'
1944 # Given a GIT_TRACE2_EVENT log over stdin, writes to stdout a list of URLs
1945 # sent to git-remote-https child processes.
1946 test_remote_https_urls() {
1947 grep -e '"event":"child_start".*"argv":\["git-remote-https",".*"\]' |
1948 sed -e 's/{"event":"child_start".*"argv":\["git-remote-https","//g' \
1949 -e 's/"\]}//g'
1952 # Print the destination of symlink(s) provided as arguments. Basically
1953 # the same as the readlink command, but it's not available everywhere.
1954 test_readlink () {
1955 perl -le 'print readlink($_) for @ARGV' "$@"
1958 # Set mtime to a fixed "magic" timestamp in mid February 2009, before we
1959 # run an operation that may or may not touch the file. If the file was
1960 # touched, its timestamp will not accidentally have such an old timestamp,
1961 # as long as your filesystem clock is reasonably correct. To verify the
1962 # timestamp, follow up with test_is_magic_mtime.
1964 # An optional increment to the magic timestamp may be specified as second
1965 # argument.
1966 test_set_magic_mtime () {
1967 local inc="${2:-0}" &&
1968 local mtime=$((1234567890 + $inc)) &&
1969 test-tool chmtime =$mtime "$1" &&
1970 test_is_magic_mtime "$1" $inc
1973 # Test whether the given file has the "magic" mtime set. This is meant to
1974 # be used in combination with test_set_magic_mtime.
1976 # An optional increment to the magic timestamp may be specified as second
1977 # argument. Usually, this should be the same increment which was used for
1978 # the associated test_set_magic_mtime.
1979 test_is_magic_mtime () {
1980 local inc="${2:-0}" &&
1981 local mtime=$((1234567890 + $inc)) &&
1982 echo $mtime >.git/test-mtime-expect &&
1983 test-tool chmtime --get "$1" >.git/test-mtime-actual &&
1984 test_cmp .git/test-mtime-expect .git/test-mtime-actual
1985 local ret=$?
1986 rm -f .git/test-mtime-expect
1987 rm -f .git/test-mtime-actual
1988 return $ret
1991 # Given two filenames, parse both using 'git config --list --file'
1992 # and compare the sorted output of those commands. Useful when
1993 # wanting to ignore whitespace differences and sorting concerns.
1994 test_cmp_config_output () {
1995 git config --list --file="$1" >config-expect &&
1996 git config --list --file="$2" >config-actual &&
1997 sort config-expect >sorted-expect &&
1998 sort config-actual >sorted-actual &&
1999 test_cmp sorted-expect sorted-actual
2002 # Given a filename, extract its trailing hash as a hex string
2003 test_trailing_hash () {
2004 local file="$1" &&
2005 tail -c $(test_oid rawsz) "$file" |
2006 test-tool hexdump |
2007 sed "s/ //g"